
import Taro, { Component } from '@tarojs/taro'
import { View, Text } from '@tarojs/components'
import { AtInput, AtImagePicker, AtTextarea, AtButton, Picker, AtToast } from 'taro-ui'

import CopyrightComponent from '../../component/copyrightComponent/copyrightComponent'
import URL from '../../serviceAPI.config'


import './myDemandSupplyEdit.scss'



class MyDemandSupplyEdit extends Component {

    config = {
        navigationBarTitleText: '我的供求编辑'
    }
    constructor() {
        super(...arguments)
        this.state = {
            demandingSupplyCate: ['需求', '供应', '人才'], //供求类型选择
            demandingSupplyCateSelected: '需求',// 当前供求类型
            demandingSupplyState: ['上架', '下架'], // 状态选择
            demandingSupplyStateSelected: '上架',// 当前状态
            title: '',
            contactName: '',
            contactNumber: '',
            contactAddress: '',
            content: '',
            pickerImageUrl: [], // 上传的图片
            ImagesInfo: [],// 后台传回来的图片信息
            isUploadImageSuccess: false,
            uploadImageTextTip: '',
            isFormCompleted: false,
            isUploadDemSupSuccess: false,
            uploadDemSupTextTip: '',

        }
    }

    // 上传供求api
    uploadSupplyDemand() {
        if (this.state.demandingSupplyCateSelected && this.state.title && this.state.contactName && this.state.contactNumber && this.state.contactAddress && this.state.content && this.state.demandingSupplyStateSelected) {
            this.uploadDemSup({})
        } else {
            this.setState({ uploadDemSupTextTip: '请填写完表格', isUploadDemSupSuccess: true }, () => {
                setTimeout(() => {
                    this.setState({ isUploadDemSupSuccess: false })
                }, 2000)
            })
        }

        // Taro.request({
        //     url: URL.UploadSupplyDemand,
        //     method: 'POST',
        //     dataType: 'json',
        //     data: {
        //         action: 1,
        //         sdInfo: JSON.stringify({ "sd_type": "2", "sd_title": "534523", "user_name": "杨夕兵", "user_phone": "18950295811", "user_address": "2342", "sd_desc": "42342", "state": "1", "file_path": [{ "file_name": "bg3.jpg", "file_size": "212678", "file_path": "Uploads/supply/user_27/201812/38bf91f30d215bbefb2686f2401217a6.jpg", "thumb_path": "Uploads/supply/user_27/201812/thumb/38bf91f30d215bbefb2686f2401217a6_200X200.jpg" }] })
        //     },
        //     header: {
        //         'content-type': 'application/x-www-form-urlencoded',
        //     }
        // })
        //     .then(res => {
        //         console.log('上传供求', res)
        //     }
        //     )
    }

    // 这个需要写一个uploadDemSup 上传供求 的api


    // 上传图片
    onChangeImg(files, operationType, index) {
        const that = this
        if (operationType === 'add') {
            Taro.uploadFile({
                url: URL.UploadDSPorductImage,
                filePath: files[files.length - 1].url,
                name: 'file',
                header: {
                    'content-type': 'multipart/form-data',
                    'Cookie': 'PFWSSS=' + Taro.getStorageSync('session_id'),
                    'X-Requested-With': 'XMLHttpRequest'
                },
                success(response) {
                    const data = JSON.parse(response.data)
                    const imagePath = URL.Base + data.file_path
                    const newPickerImageUrl = that.state.pickerImageUrl.concat({ url: imagePath })
                    const newImageInfo = that.state.ImagesInfo.concat(data)
                    that.setState({ pickerImageUrl: newPickerImageUrl, isUploadImageSuccess: true, uploadImageTextTip: '图片上传成功', ImagesInfo: newImageInfo }, () => {
                        setTimeout(() => {
                            that.setState({ isUploadImageSuccess: false })
                        }, 2000)
                    })
                }
            })
        }
        if (operationType === 'remove') {
            this.state.pickerImageUrl.splice(index, 1);
            this.setState({ files: this.state.pickerImageUrl });
            that.setState({ isUploadImageSuccess: true, uploadImageTextTip: '删除成功' }, () => {
                setTimeout(() => {
                    that.setState({ isUploadImageSuccess: false })
                }, 2000)
            })
        }
    }
    // 修改供求类型
    demandingSupplyCate = e => {
        this.setState({
            demandingSupplyCateSelected: this.state.demandingSupplyCate[e.detail.value]
        })
    }
    // 修改供求状态
    demSupplyStateChange = e => {
        this.setState({
            demandingSupplyStateSelected: this.state.demandingSupplyState[e.detail.value]
        })
    }
    //改标题
    titleChange(event) {
        this.setState({ title: event })
    }
    contactNameChange(event) {
        this.setState({ contactName: event })
    }
    contactNumberChange(event) {
        this.setState({ contactNumber: event })
    }
    contactAddressChange(event) {
        this.setState({ contactAddress: event.target.value })
    }
    contentChange(event) {
        this.setState({ content: event.target.value })
    }
    goToMyDemSupPage(){
        Taro.navigateTo({
             url: '/pages/mySupplyDemand/mySupplyDemand'
          })
    }


    componentDidMount() {
        // this.uploadSupplyDemand()
    }
    componentWillReceiveProps(nextProps) {
        console.log(this.props, nextProps)
    }

    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        const imageUploadSuccessElement = <AtToast
          isOpened={this.state.isUploadImageSuccess}
          text={this.state.uploadImageTextTip}
          duration={2000}
        ></AtToast>
        const demandSupplyUploadSuccessElement = <AtToast
          isOpened={this.state.isUploadDemSupSuccess}
          text={this.state.uploadDemSupTextTip}
          duration={2000}
        ></AtToast>
        return (
            <View className='supply-demand'>
                {/* 图片上传模态框 */}
                {imageUploadSuccessElement}
                {/* 商品发布模态框 */}
                {demandSupplyUploadSuccessElement}
               
                <View className='page-section'>
                    <View>
                        <Picker mode='selector' range={this.state.demandingSupplyCate} onChange={this.demandingSupplyCate.bind(this)}>
                            <View className='picker'>
                                <View className='title-box'>
                                    <Text className='title'><Text className='require'>*</Text>供求类型:</Text> <Text className='selected'>{this.state.demandingSupplyCateSelected}</Text>
                                </View>

                            </View>
                        </Picker>
                    </View>
                </View>
                <View className='border-box'>
                    <Text className='require'>*</Text><AtInput
                      name='value'
                      title='需求标题：'
                      type='text'
                      value={this.state.title}
                      onChange={this.titleChange.bind(this)}
                    />
                </View>
                <View className='input-box'>
                    <Text className='require'>*</Text>
                    <AtInput
                      name='value'
                      title='联系人：'
                      type='text'
                      value={this.state.contactName}
                      onChange={this.contactNameChange.bind(this)}
                    />
                </View>
                <View className='input-box'>
                    <Text className='require'>*</Text>
                    <AtInput
                      name='value'
                      title='联系电话：'
                      type='number'
                      value={this.state.contactNumber}
                      onChange={this.contactNumberChange.bind(this)}
                    />
                </View>
                <View className='demanding-box'>
                    <View className='title-box'>
                        <Text className='title'><Text className='require'>*</Text>联系地址:</Text>
                    </View>

                    <AtTextarea
                      value={this.state.contactAddress}
                      onChange={this.contactAddressChange.bind(this)}
                      maxlength='200'
                      placeholder='联系地址'
                    />
                </View>
                <View className='demanding-box'>
                    <View className='title-box'>
                        <Text className='title'><Text className='require'>*</Text>需求内容:</Text>
                    </View>
                    <AtTextarea
                      value={this.state.content}
                      onChange={this.contentChange.bind(this)}
                      maxlength='200'
                      placeholder=''
                    />
                </View>
                <View className='img-box'>
                    <View className='title-box'>
                        <Text className='title'>需求图片:</Text>
                        <View className='warn'>(最多4张)</View>
                    </View>

                    <View className='img-container'>
                        <AtImagePicker
                          multiple
                          showAddBtn={this.state.pickerImageUrl.length<4}
                          files={this.state.pickerImageUrl}
                          onChange={this.onChangeImg.bind(this)}
                          onFail={this.onFail.bind(this)}
                          onImageClick={this.onImageClick.bind(this)}
                        />
                    </View>

                </View>
                <View className='page-section'>

                    <View>
                        <Picker mode='selector' range={this.state.demandingSupplyState} onChange={this.demSupplyStateChange}>
                            <View className='picker'>
                                <View className='title-box'>
                                    <Text className='title'> <Text className='require'>*</Text>状态:</Text> <Text className='selected'>{this.state.demandingSupplyStateSelected}</Text>
                                </View>

                            </View>
                        </Picker>
                    </View>
                </View>

                <View className='button-box'>
                    <View className='button' onClick={this.uploadSupplyDemand.bind(this)}>
                        <AtButton type='primary' size='small'>保存</AtButton>
                    </View>
                    {/* <View className='button'>

                        <AtButton type='primary' className='button-a' size='small'>保存并新增</AtButton>
                    </View> */}
                    <View className='button' onClick={this.goToMyDemSupPage.bind(this)}>
                        <AtButton type='primary' className='button-a' size='small'>我的供求</AtButton>
                    </View>
                </View>
                <CopyrightComponent></CopyrightComponent>


            </View>
        )
    }
}

export default MyDemandSupplyEdit
